Index: issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHutter/UpdateElementsDiagnosticHutter.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHutter/UpdateElementsDiagnosticHutter.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticHutter/UpdateElementsDiagnosticHutter.cpp	(revision 15564)
@@ -1,4 +1,4 @@
 /*
- * UpdateElementsDiagnosticHutter:
+ * UpdateElementsDiagnosticSIA:
  */
 
@@ -9,12 +9,12 @@
 #include "../ModelProcessorx.h"
 
-void	UpdateElementsDiagnosticHutter(Elements* elements, IoModel* iomodel,int analysis_counter,int analysis_type){
+void	UpdateElementsDiagnosticSIA(Elements* elements, IoModel* iomodel,int analysis_counter,int analysis_type){
 
 	/*Fetch data needed: */
-	bool   ishutter;
-	iomodel->Constant(&ishutter,FlowequationIshutterEnum);
+	bool   isSIA;
+	iomodel->Constant(&isSIA,FlowequationIsSIAEnum);
 
-	/*Now, is the flag hutter on? otherwise, do nothing: */
-	if (!ishutter)return;
+	/*Now, is the flag SIA on? otherwise, do nothing: */
+	if (!isSIA)return;
 
 	iomodel->FetchData(1,FlowequationElementEquationEnum);
Index: issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticVert/CreateConstraintsDiagnosticVert.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticVert/CreateConstraintsDiagnosticVert.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticVert/CreateConstraintsDiagnosticVert.cpp	(revision 15564)
@@ -24,5 +24,5 @@
 
 	/*Fetch data: */
-	iomodel->FetchData(2,DiagnosticSpcvzEnum,FlowequationBorderstokesEnum);
+	iomodel->FetchData(2,DiagnosticSpcvzEnum,FlowequationBorderFSEnum);
 
 	/*Initialize counter*/
@@ -35,6 +35,6 @@
 		if(iomodel->my_vertices[i]){
 
-			if (reCast<int,IssmDouble>(iomodel->Data(FlowequationBorderstokesEnum)[i])){
-				constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,1,0,DiagnosticVertAnalysisEnum)); //spc to zero as vertical velocity is done in Horiz for Stokes
+			if (reCast<int,IssmDouble>(iomodel->Data(FlowequationBorderFSEnum)[i])){
+				constraints->AddObject(new SpcStatic(iomodel->constraintcounter+count+1,iomodel->nodecounter+i+1,1,0,DiagnosticVertAnalysisEnum)); //spc to zero as vertical velocity is done in Horiz for FS
 				count++;
 			}
@@ -49,5 +49,5 @@
 
 	/*Free data: */
-	iomodel->DeleteData(2,DiagnosticSpcvzEnum,FlowequationBorderstokesEnum);
+	iomodel->DeleteData(2,DiagnosticSpcvzEnum,FlowequationBorderFSEnum);
 
 	/*Assign output pointer: */
Index: issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticVert/CreateNodesDiagnosticVert.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticVert/CreateNodesDiagnosticVert.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/modules/ModelProcessorx/DiagnosticVert/CreateNodesDiagnosticVert.cpp	(revision 15564)
@@ -11,5 +11,5 @@
 void	CreateNodesDiagnosticVert(Nodes** pnodes, IoModel* iomodel){
 
-	/*Now, is the flag macayaealpattyn on? otherwise, do nothing: */
+	/*Now, is the flag macayaealHO on? otherwise, do nothing: */
 	if(iomodel->dim==2) return;
 
Index: issm/trunk-jpl/src/c/modules/ModelProcessorx/DistributeNumDofs.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/ModelProcessorx/DistributeNumDofs.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/modules/ModelProcessorx/DistributeNumDofs.cpp	(revision 15564)
@@ -24,11 +24,11 @@
 					numdofs=2;
 					break;
-				case PattynApproximationEnum:
+				case HOApproximationEnum:
 					numdofs=2;
 					break;
-				case HutterApproximationEnum:
+				case SIAApproximationEnum:
 					numdofs=2;
 					break;
-				case StokesApproximationEnum:
+				case FSApproximationEnum:
 					numdofs=4;
 					break;
@@ -36,31 +36,31 @@
 					numdofs=4;
 					break;
-				case MacAyealPattynApproximationEnum:
+				case MacAyealHOApproximationEnum:
 					numdofs=4;
 					doftype=xNew<int>(numdofs);
 					doftype[0]=MacAyealApproximationEnum;
 					doftype[1]=MacAyealApproximationEnum;
-					doftype[2]=PattynApproximationEnum;
-					doftype[3]=PattynApproximationEnum;
+					doftype[2]=HOApproximationEnum;
+					doftype[3]=HOApproximationEnum;
 					break;
-				case PattynStokesApproximationEnum:
+				case HOFSApproximationEnum:
 					numdofs=6;
 					doftype=xNew<int>(numdofs);
-					doftype[0]=PattynApproximationEnum;
-					doftype[1]=PattynApproximationEnum;
-					doftype[2]=StokesApproximationEnum;
-					doftype[3]=StokesApproximationEnum;
-					doftype[4]=StokesApproximationEnum;
-					doftype[5]=StokesApproximationEnum;
+					doftype[0]=HOApproximationEnum;
+					doftype[1]=HOApproximationEnum;
+					doftype[2]=FSApproximationEnum;
+					doftype[3]=FSApproximationEnum;
+					doftype[4]=FSApproximationEnum;
+					doftype[5]=FSApproximationEnum;
 					break;
-				case MacAyealStokesApproximationEnum:
+				case MacAyealFSApproximationEnum:
 					numdofs=6;
 					doftype=xNew<int>(numdofs);
 					doftype[0]=MacAyealApproximationEnum;
 					doftype[1]=MacAyealApproximationEnum;
-					doftype[2]=StokesApproximationEnum;
-					doftype[3]=StokesApproximationEnum;
-					doftype[4]=StokesApproximationEnum;
-					doftype[5]=StokesApproximationEnum;
+					doftype[2]=FSApproximationEnum;
+					doftype[3]=FSApproximationEnum;
+					doftype[4]=FSApproximationEnum;
+					doftype[5]=FSApproximationEnum;
 					break;
 				default:
@@ -72,5 +72,5 @@
 			numdofs=1;
 			break;
-		case DiagnosticHutterAnalysisEnum:
+		case DiagnosticSIAAnalysisEnum:
 			numdofs=2;
 			break;
Index: issm/trunk-jpl/src/c/modules/ModelProcessorx/ModelProcessorx.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/ModelProcessorx/ModelProcessorx.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/modules/ModelProcessorx/ModelProcessorx.cpp	(revision 15564)
@@ -59,5 +59,5 @@
 		if(solution_type==TransientSolutionEnum && analysis_type==DiagnosticHorizAnalysisEnum && isdiagnostic==false) continue;
 		if(solution_type==TransientSolutionEnum && analysis_type==DiagnosticVertAnalysisEnum && isdiagnostic==false) continue;
-		if(solution_type==TransientSolutionEnum && analysis_type==DiagnosticHutterAnalysisEnum && isdiagnostic==false) continue;
+		if(solution_type==TransientSolutionEnum && analysis_type==DiagnosticSIAAnalysisEnum && isdiagnostic==false) continue;
 		if(solution_type==SteadystateSolutionEnum && analysis_type==ThermalAnalysisEnum && isenthalpy==true) continue;
 		if(solution_type==SteadystateSolutionEnum && analysis_type==MeltingAnalysisEnum && isenthalpy==true) continue;
Index: issm/trunk-jpl/src/c/modules/ModelProcessorx/ModelProcessorx.h
===================================================================
--- issm/trunk-jpl/src/c/modules/ModelProcessorx/ModelProcessorx.h	(revision 15563)
+++ issm/trunk-jpl/src/c/modules/ModelProcessorx/ModelProcessorx.h	(revision 15564)
@@ -39,9 +39,9 @@
 void UpdateElementsDiagnosticVert(Elements* elements,IoModel* iomodel,int analysis_counter,int analysis_type);
 
-/*diagnostic hutter*/
-void CreateNodesDiagnosticHutter(Nodes** pnodes,IoModel* iomodel);
-void CreateConstraintsDiagnosticHutter(Constraints** pconstraints,IoModel* iomodel);
-void CreateLoadsDiagnosticHutter(Loads** ploads, IoModel* iomodel);
-void UpdateElementsDiagnosticHutter(Elements* elements,IoModel* iomodel,int analysis_counter,int analysis_type);
+/*diagnostic SIA*/
+void CreateNodesDiagnosticSIA(Nodes** pnodes,IoModel* iomodel);
+void CreateConstraintsDiagnosticSIA(Constraints** pconstraints,IoModel* iomodel);
+void CreateLoadsDiagnosticSIA(Loads** ploads, IoModel* iomodel);
+void UpdateElementsDiagnosticSIA(Elements* elements,IoModel* iomodel,int analysis_counter,int analysis_type);
 
 #ifdef _HAVE_GIA_
Index: issm/trunk-jpl/src/c/modules/ResetCoordinateSystemx/ResetCoordinateSystemx.cpp
===================================================================
--- issm/trunk-jpl/src/c/modules/ResetCoordinateSystemx/ResetCoordinateSystemx.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/modules/ResetCoordinateSystemx/ResetCoordinateSystemx.cpp	(revision 15564)
@@ -1,4 +1,4 @@
 /*!\file ResetCoordinateSystemx
- * \brief: reset coordinate system for full-Stokes: tangential to the bedrock
+ * \brief: reset coordinate system for full-FS: tangential to the bedrock
  */
 
Index: issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h	(revision 15563)
+++ issm/trunk-jpl/src/c/shared/Enum/EnumDefinitions.h	(revision 15564)
@@ -57,5 +57,5 @@
 	DiagnosticSpcvyEnum,
 	DiagnosticSpcvzEnum,
-	DiagnosticStokesreconditioningEnum,
+	DiagnosticFSreconditioningEnum,
 	DiagnosticVertexPairingEnum,
 	DiagnosticViscosityOvershootEnum,
@@ -63,15 +63,15 @@
 	LoadingforceYEnum,
 	LoadingforceZEnum,
-	FlowequationBordermacayealEnum,
-	FlowequationBorderpattynEnum,
-	FlowequationBorderstokesEnum,
+	FlowequationBorderSSAEnum,
+	FlowequationBorderHOEnum,
+	FlowequationBorderFSEnum,
 	FlowequationElementEquationEnum,
-	FlowequationIshutterEnum,
-	FlowequationIsmacayealEnum,
-	FlowequationIsl1l2Enum,
-	FlowequationIspattynEnum,
-	FlowequationIsstokesEnum,
-	FlowequationFeStokesEnum,
-	FlowequationFeSsaEnum,
+	FlowequationIsSIAEnum,
+	FlowequationIsSSAEnum,
+	FlowequationIsL1L2Enum,
+	FlowequationIsHOEnum,
+	FlowequationIsFSEnum,
+	FlowequationFeFSEnum,
+	FlowequationFeSSAEnum,
 	FlowequationVertexEquationEnum,
 	FrictionCoefficientEnum,
@@ -282,5 +282,5 @@
 	BedSlopeYAnalysisEnum,
 	DiagnosticHorizAnalysisEnum,
-	DiagnosticHutterAnalysisEnum,
+	DiagnosticSIAAnalysisEnum,
 	DiagnosticSolutionEnum,
 	DiagnosticVertAnalysisEnum,
@@ -310,12 +310,12 @@
 	ApproximationEnum,
 	NoneApproximationEnum,
-	HutterApproximationEnum,
+	SIAApproximationEnum,
 	MacAyealApproximationEnum,
-	MacAyealPattynApproximationEnum,
-	MacAyealStokesApproximationEnum,
+	MacAyealHOApproximationEnum,
+	MacAyealFSApproximationEnum,
 	L1L2ApproximationEnum,
-	PattynApproximationEnum,
-	PattynStokesApproximationEnum,
-	StokesApproximationEnum,
+	HOApproximationEnum,
+	HOFSApproximationEnum,
+	FSApproximationEnum,
 	/*}}}*/
 	/*Datasets {{{*/
@@ -366,5 +366,5 @@
 	ParamEnum,
 	L1L2IceFrontEnum,
-	PattynIceFrontEnum,
+	HOIceFrontEnum,
 	PengridEnum,
 	PenpairEnum,
@@ -382,5 +382,5 @@
 	SpcStaticEnum,
 	SpcTransientEnum,
-	StokesIceFrontEnum,
+	FSIceFrontEnum,
 	StringArrayParamEnum,
 	StringParamEnum,
@@ -461,7 +461,7 @@
 	VzEnum,
 	VzMacAyealEnum,
-	VzPattynEnum,
+	VzHOEnum,
 	VzPicardEnum,
-	VzStokesEnum,
+	VzFSEnum,
 	VxMeshEnum,
 	VyMeshEnum,
@@ -553,5 +553,5 @@
 	/*}}}*/
 	/*Solver{{{*/
-	StokesSolverEnum,
+	FSSolverEnum,
 	/*}}}*/
 	/*Parameters{{{*/
Index: issm/trunk-jpl/src/c/shared/Enum/EnumToStringx.cpp
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/EnumToStringx.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/shared/Enum/EnumToStringx.cpp	(revision 15564)
@@ -65,5 +65,5 @@
 		case DiagnosticSpcvyEnum : return "DiagnosticSpcvy";
 		case DiagnosticSpcvzEnum : return "DiagnosticSpcvz";
-		case DiagnosticStokesreconditioningEnum : return "DiagnosticStokesreconditioning";
+		case DiagnosticFSreconditioningEnum : return "DiagnosticFSreconditioning";
 		case DiagnosticVertexPairingEnum : return "DiagnosticVertexPairing";
 		case DiagnosticViscosityOvershootEnum : return "DiagnosticViscosityOvershoot";
@@ -71,15 +71,15 @@
 		case LoadingforceYEnum : return "LoadingforceY";
 		case LoadingforceZEnum : return "LoadingforceZ";
-		case FlowequationBordermacayealEnum : return "FlowequationBordermacayeal";
-		case FlowequationBorderpattynEnum : return "FlowequationBorderpattyn";
-		case FlowequationBorderstokesEnum : return "FlowequationBorderstokes";
+		case FlowequationBorderSSAEnum : return "FlowequationBorderSSA";
+		case FlowequationBorderHOEnum : return "FlowequationBorderHO";
+		case FlowequationBorderFSEnum : return "FlowequationBorderFS";
 		case FlowequationElementEquationEnum : return "FlowequationElementEquation";
-		case FlowequationIshutterEnum : return "FlowequationIshutter";
-		case FlowequationIsmacayealEnum : return "FlowequationIsmacayeal";
-		case FlowequationIsl1l2Enum : return "FlowequationIsl1l2";
-		case FlowequationIspattynEnum : return "FlowequationIspattyn";
-		case FlowequationIsstokesEnum : return "FlowequationIsstokes";
-		case FlowequationFeStokesEnum : return "FlowequationFeStokes";
-		case FlowequationFeSsaEnum : return "FlowequationFeSsa";
+		case FlowequationIsSIAEnum : return "FlowequationIsSIA";
+		case FlowequationIsSSAEnum : return "FlowequationIsSSA";
+		case FlowequationIsL1L2Enum : return "FlowequationIsL1L2";
+		case FlowequationIsHOEnum : return "FlowequationIsHO";
+		case FlowequationIsFSEnum : return "FlowequationIsFS";
+		case FlowequationFeFSEnum : return "FlowequationFeFS";
+		case FlowequationFeSSAEnum : return "FlowequationFeSSA";
 		case FlowequationVertexEquationEnum : return "FlowequationVertexEquation";
 		case FrictionCoefficientEnum : return "FrictionCoefficient";
@@ -288,5 +288,5 @@
 		case BedSlopeYAnalysisEnum : return "BedSlopeYAnalysis";
 		case DiagnosticHorizAnalysisEnum : return "DiagnosticHorizAnalysis";
-		case DiagnosticHutterAnalysisEnum : return "DiagnosticHutterAnalysis";
+		case DiagnosticSIAAnalysisEnum : return "DiagnosticSIAAnalysis";
 		case DiagnosticSolutionEnum : return "DiagnosticSolution";
 		case DiagnosticVertAnalysisEnum : return "DiagnosticVertAnalysis";
@@ -314,12 +314,12 @@
 		case ApproximationEnum : return "Approximation";
 		case NoneApproximationEnum : return "NoneApproximation";
-		case HutterApproximationEnum : return "HutterApproximation";
+		case SIAApproximationEnum : return "SIAApproximation";
 		case MacAyealApproximationEnum : return "MacAyealApproximation";
-		case MacAyealPattynApproximationEnum : return "MacAyealPattynApproximation";
-		case MacAyealStokesApproximationEnum : return "MacAyealStokesApproximation";
+		case MacAyealHOApproximationEnum : return "MacAyealHOApproximation";
+		case MacAyealFSApproximationEnum : return "MacAyealFSApproximation";
 		case L1L2ApproximationEnum : return "L1L2Approximation";
-		case PattynApproximationEnum : return "PattynApproximation";
-		case PattynStokesApproximationEnum : return "PattynStokesApproximation";
-		case StokesApproximationEnum : return "StokesApproximation";
+		case HOApproximationEnum : return "HOApproximation";
+		case HOFSApproximationEnum : return "HOFSApproximation";
+		case FSApproximationEnum : return "FSApproximation";
 		case ConstraintsEnum : return "Constraints";
 		case LoadsEnum : return "Loads";
@@ -366,5 +366,5 @@
 		case ParamEnum : return "Param";
 		case L1L2IceFrontEnum : return "L1L2IceFront";
-		case PattynIceFrontEnum : return "PattynIceFront";
+		case HOIceFrontEnum : return "HOIceFront";
 		case PengridEnum : return "Pengrid";
 		case PenpairEnum : return "Penpair";
@@ -382,5 +382,5 @@
 		case SpcStaticEnum : return "SpcStatic";
 		case SpcTransientEnum : return "SpcTransient";
-		case StokesIceFrontEnum : return "StokesIceFront";
+		case FSIceFrontEnum : return "FSIceFront";
 		case StringArrayParamEnum : return "StringArrayParam";
 		case StringParamEnum : return "StringParam";
@@ -455,7 +455,7 @@
 		case VzEnum : return "Vz";
 		case VzMacAyealEnum : return "VzMacAyeal";
-		case VzPattynEnum : return "VzPattyn";
+		case VzHOEnum : return "VzHO";
 		case VzPicardEnum : return "VzPicard";
-		case VzStokesEnum : return "VzStokes";
+		case VzFSEnum : return "VzFS";
 		case VxMeshEnum : return "VxMesh";
 		case VyMeshEnum : return "VyMesh";
@@ -535,5 +535,5 @@
 		case SubelementMigration2Enum : return "SubelementMigration2";
 		case GLlevelsetEnum : return "GLlevelset";
-		case StokesSolverEnum : return "StokesSolver";
+		case FSSolverEnum : return "FSSolver";
 		case AdjointEnum : return "Adjoint";
 		case ColinearEnum : return "Colinear";
Index: issm/trunk-jpl/src/c/shared/Enum/StringToEnumx.cpp
===================================================================
--- issm/trunk-jpl/src/c/shared/Enum/StringToEnumx.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/shared/Enum/StringToEnumx.cpp	(revision 15564)
@@ -65,5 +65,5 @@
 	      else if (strcmp(name,"DiagnosticSpcvy")==0) return DiagnosticSpcvyEnum;
 	      else if (strcmp(name,"DiagnosticSpcvz")==0) return DiagnosticSpcvzEnum;
-	      else if (strcmp(name,"DiagnosticStokesreconditioning")==0) return DiagnosticStokesreconditioningEnum;
+	      else if (strcmp(name,"DiagnosticFSreconditioning")==0) return DiagnosticFSreconditioningEnum;
 	      else if (strcmp(name,"DiagnosticVertexPairing")==0) return DiagnosticVertexPairingEnum;
 	      else if (strcmp(name,"DiagnosticViscosityOvershoot")==0) return DiagnosticViscosityOvershootEnum;
@@ -71,15 +71,15 @@
 	      else if (strcmp(name,"LoadingforceY")==0) return LoadingforceYEnum;
 	      else if (strcmp(name,"LoadingforceZ")==0) return LoadingforceZEnum;
-	      else if (strcmp(name,"FlowequationBordermacayeal")==0) return FlowequationBordermacayealEnum;
-	      else if (strcmp(name,"FlowequationBorderpattyn")==0) return FlowequationBorderpattynEnum;
-	      else if (strcmp(name,"FlowequationBorderstokes")==0) return FlowequationBorderstokesEnum;
+	      else if (strcmp(name,"FlowequationBorderSSA")==0) return FlowequationBorderSSAEnum;
+	      else if (strcmp(name,"FlowequationBorderHO")==0) return FlowequationBorderHOEnum;
+	      else if (strcmp(name,"FlowequationBorderFS")==0) return FlowequationBorderFSEnum;
 	      else if (strcmp(name,"FlowequationElementEquation")==0) return FlowequationElementEquationEnum;
-	      else if (strcmp(name,"FlowequationIshutter")==0) return FlowequationIshutterEnum;
-	      else if (strcmp(name,"FlowequationIsmacayeal")==0) return FlowequationIsmacayealEnum;
-	      else if (strcmp(name,"FlowequationIsl1l2")==0) return FlowequationIsl1l2Enum;
-	      else if (strcmp(name,"FlowequationIspattyn")==0) return FlowequationIspattynEnum;
-	      else if (strcmp(name,"FlowequationIsstokes")==0) return FlowequationIsstokesEnum;
-	      else if (strcmp(name,"FlowequationFeStokes")==0) return FlowequationFeStokesEnum;
-	      else if (strcmp(name,"FlowequationFeSsa")==0) return FlowequationFeSsaEnum;
+	      else if (strcmp(name,"FlowequationIsSIA")==0) return FlowequationIsSIAEnum;
+	      else if (strcmp(name,"FlowequationIsSSA")==0) return FlowequationIsSSAEnum;
+	      else if (strcmp(name,"FlowequationIsL1L2")==0) return FlowequationIsL1L2Enum;
+	      else if (strcmp(name,"FlowequationIsHO")==0) return FlowequationIsHOEnum;
+	      else if (strcmp(name,"FlowequationIsFS")==0) return FlowequationIsFSEnum;
+	      else if (strcmp(name,"FlowequationFeFS")==0) return FlowequationFeFSEnum;
+	      else if (strcmp(name,"FlowequationFeSSA")==0) return FlowequationFeSSAEnum;
 	      else if (strcmp(name,"FlowequationVertexEquation")==0) return FlowequationVertexEquationEnum;
 	      else if (strcmp(name,"FrictionCoefficient")==0) return FrictionCoefficientEnum;
@@ -294,5 +294,5 @@
 	      else if (strcmp(name,"BedSlopeYAnalysis")==0) return BedSlopeYAnalysisEnum;
 	      else if (strcmp(name,"DiagnosticHorizAnalysis")==0) return DiagnosticHorizAnalysisEnum;
-	      else if (strcmp(name,"DiagnosticHutterAnalysis")==0) return DiagnosticHutterAnalysisEnum;
+	      else if (strcmp(name,"DiagnosticSIAAnalysis")==0) return DiagnosticSIAAnalysisEnum;
 	      else if (strcmp(name,"DiagnosticSolution")==0) return DiagnosticSolutionEnum;
 	      else if (strcmp(name,"DiagnosticVertAnalysis")==0) return DiagnosticVertAnalysisEnum;
@@ -320,12 +320,12 @@
 	      else if (strcmp(name,"Approximation")==0) return ApproximationEnum;
 	      else if (strcmp(name,"NoneApproximation")==0) return NoneApproximationEnum;
-	      else if (strcmp(name,"HutterApproximation")==0) return HutterApproximationEnum;
+	      else if (strcmp(name,"SIAApproximation")==0) return SIAApproximationEnum;
 	      else if (strcmp(name,"MacAyealApproximation")==0) return MacAyealApproximationEnum;
-	      else if (strcmp(name,"MacAyealPattynApproximation")==0) return MacAyealPattynApproximationEnum;
-	      else if (strcmp(name,"MacAyealStokesApproximation")==0) return MacAyealStokesApproximationEnum;
+	      else if (strcmp(name,"MacAyealHOApproximation")==0) return MacAyealHOApproximationEnum;
+	      else if (strcmp(name,"MacAyealFSApproximation")==0) return MacAyealFSApproximationEnum;
 	      else if (strcmp(name,"L1L2Approximation")==0) return L1L2ApproximationEnum;
-	      else if (strcmp(name,"PattynApproximation")==0) return PattynApproximationEnum;
-	      else if (strcmp(name,"PattynStokesApproximation")==0) return PattynStokesApproximationEnum;
-	      else if (strcmp(name,"StokesApproximation")==0) return StokesApproximationEnum;
+	      else if (strcmp(name,"HOApproximation")==0) return HOApproximationEnum;
+	      else if (strcmp(name,"HOFSApproximation")==0) return HOFSApproximationEnum;
+	      else if (strcmp(name,"FSApproximation")==0) return FSApproximationEnum;
 	      else if (strcmp(name,"Constraints")==0) return ConstraintsEnum;
 	      else if (strcmp(name,"Loads")==0) return LoadsEnum;
@@ -372,5 +372,5 @@
 	      else if (strcmp(name,"Param")==0) return ParamEnum;
 	      else if (strcmp(name,"L1L2IceFront")==0) return L1L2IceFrontEnum;
-	      else if (strcmp(name,"PattynIceFront")==0) return PattynIceFrontEnum;
+	      else if (strcmp(name,"HOIceFront")==0) return HOIceFrontEnum;
 	      else if (strcmp(name,"Pengrid")==0) return PengridEnum;
 	      else if (strcmp(name,"Penpair")==0) return PenpairEnum;
@@ -391,5 +391,5 @@
 	      else if (strcmp(name,"SpcStatic")==0) return SpcStaticEnum;
 	      else if (strcmp(name,"SpcTransient")==0) return SpcTransientEnum;
-	      else if (strcmp(name,"StokesIceFront")==0) return StokesIceFrontEnum;
+	      else if (strcmp(name,"FSIceFront")==0) return FSIceFrontEnum;
 	      else if (strcmp(name,"StringArrayParam")==0) return StringArrayParamEnum;
 	      else if (strcmp(name,"StringParam")==0) return StringParamEnum;
@@ -464,7 +464,7 @@
 	      else if (strcmp(name,"Vz")==0) return VzEnum;
 	      else if (strcmp(name,"VzMacAyeal")==0) return VzMacAyealEnum;
-	      else if (strcmp(name,"VzPattyn")==0) return VzPattynEnum;
+	      else if (strcmp(name,"VzHO")==0) return VzHOEnum;
 	      else if (strcmp(name,"VzPicard")==0) return VzPicardEnum;
-	      else if (strcmp(name,"VzStokes")==0) return VzStokesEnum;
+	      else if (strcmp(name,"VzFS")==0) return VzFSEnum;
 	      else if (strcmp(name,"VxMesh")==0) return VxMeshEnum;
 	      else if (strcmp(name,"VyMesh")==0) return VyMeshEnum;
@@ -547,5 +547,5 @@
 	      else if (strcmp(name,"SubelementMigration2")==0) return SubelementMigration2Enum;
 	      else if (strcmp(name,"GLlevelset")==0) return GLlevelsetEnum;
-	      else if (strcmp(name,"StokesSolver")==0) return StokesSolverEnum;
+	      else if (strcmp(name,"FSSolver")==0) return FSSolverEnum;
 	      else if (strcmp(name,"Adjoint")==0) return AdjointEnum;
 	      else if (strcmp(name,"Colinear")==0) return ColinearEnum;
Index: issm/trunk-jpl/src/c/solutionsequences/solutionsequence_stokescoupling_nonlinear.cpp
===================================================================
--- issm/trunk-jpl/src/c/solutionsequences/solutionsequence_stokescoupling_nonlinear.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/solutionsequences/solutionsequence_stokescoupling_nonlinear.cpp	(revision 15564)
@@ -1,4 +1,4 @@
-/*!\file: solutionsequence_stokescoupling_nonlinear.cpp
- * \brief: core of the coupling between stokes and macayealpattyn
+/*!\file: solutionsequence_FScoupling_nonlinear.cpp
+ * \brief: core of the coupling between FS and SSAHO
  */ 
 
@@ -9,5 +9,5 @@
 #include "../modules/modules.h"
 
-void solutionsequence_stokescoupling_nonlinear(FemModel* femmodel,bool conserve_loads){
+void solutionsequence_FScoupling_nonlinear(FemModel* femmodel,bool conserve_loads){
 
 	/*intermediary: */
Index: issm/trunk-jpl/src/c/solutionsequences/solutionsequences.h
===================================================================
--- issm/trunk-jpl/src/c/solutionsequences/solutionsequences.h	(revision 15563)
+++ issm/trunk-jpl/src/c/solutionsequences/solutionsequences.h	(revision 15564)
@@ -16,5 +16,5 @@
 void solutionsequence_nonlinear(FemModel* femmodel,bool conserve_loads);
 void solutionsequence_newton(FemModel* femmodel);
-void solutionsequence_stokescoupling_nonlinear(FemModel* femmodel,bool conserve_loads);
+void solutionsequence_FScoupling_nonlinear(FemModel* femmodel,bool conserve_loads);
 void solutionsequence_linear(FemModel* femmodel);
 void solutionsequence_adjoint_linear(FemModel* femmodel);
Index: issm/trunk-jpl/src/c/toolkits/petsc/objects/PetscSolver.cpp
===================================================================
--- issm/trunk-jpl/src/c/toolkits/petsc/objects/PetscSolver.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/toolkits/petsc/objects/PetscSolver.cpp	(revision 15564)
@@ -52,5 +52,5 @@
 	#endif
 
-	/*Stokes: */
+	/*FS: */
 	IS         isv=NULL;
 	IS         isp=NULL;
@@ -118,9 +118,9 @@
 	}
 
-	/*Stokes: */
-	if (solver_type==StokesSolverEnum){
+	/*FS: */
+	if (solver_type==FSSolverEnum){
 		/*Make indices out of doftypes: */
-		if(!df)_error_("need doftypes for Stokes solver!\n");
-		DofTypesToIndexSet(&isv,&isp,df,StokesSolverEnum);
+		if(!df)_error_("need doftypes for FS solver!\n");
+		DofTypesToIndexSet(&isv,&isp,df,FSSolverEnum);
 
 		/*Set field splits: */
@@ -179,5 +179,5 @@
 	int      velocity_count=0;
 
-	if(typeenum==StokesSolverEnum){
+	if(typeenum==FSSolverEnum){
 
 		/*Ok, recover doftypes vector values and indices: */
Index: issm/trunk-jpl/src/c/toolkits/petsc/patches/PetscOptionsDetermineSolverType.cpp
===================================================================
--- issm/trunk-jpl/src/c/toolkits/petsc/patches/PetscOptionsDetermineSolverType.cpp	(revision 15563)
+++ issm/trunk-jpl/src/c/toolkits/petsc/patches/PetscOptionsDetermineSolverType.cpp	(revision 15564)
@@ -60,6 +60,6 @@
 
 	PetscOptionsGetString(PETSC_NULL,"-issm_option_solver",&option[0],100,&flag);
-	if (strcmp(option,"stokes")==0){
-		solver_type=StokesSolverEnum;
+	if (strcmp(option,"FS")==0){
+		solver_type=FSSolverEnum;
 	}
 
Index: issm/trunk-jpl/src/m/classes/diagnostic.m
===================================================================
--- issm/trunk-jpl/src/m/classes/diagnostic.m	(revision 15563)
+++ issm/trunk-jpl/src/m/classes/diagnostic.m	(revision 15564)
@@ -13,5 +13,5 @@
 		abstol                   = 0;
 		isnewton                 = 0;
-		stokesreconditioning     = 0;
+		FSreconditioning     = 0;
 		viscosity_overshoot      = 0;
 		icefront                 = NaN;
@@ -45,5 +45,5 @@
 			 obj.abstol=10;
 
-			 obj.stokesreconditioning=10^13;
+			 obj.FSreconditioning=10^13;
 			 obj.shelf_dampening=0;
 
@@ -78,5 +78,5 @@
 			md = checkfield(md,'diagnostic.abstol','size',[1 1]);
 			md = checkfield(md,'diagnostic.isnewton','numel',[1],'values',[0 1 2]);
-			md = checkfield(md,'diagnostic.stokesreconditioning','size',[1 1],'NaN',1);
+			md = checkfield(md,'diagnostic.FSreconditioning','size',[1 1],'NaN',1);
 			md = checkfield(md,'diagnostic.viscosity_overshoot','size',[1 1],'NaN',1);
 			if md.mesh.dimension==2,
@@ -109,10 +109,10 @@
 			end
 			%CHECK THAT NO rotation specified for FS Grounded ice at base
-			if md.mesh.dimension==3 & md.flowequation.isstokes,
+			if md.mesh.dimension==3 & md.flowequation.isFS,
 				pos=find(md.mask.vertexongroundedice & md.mesh.vertexonbed);
 				if any(~isnan(md.diagnostic.referential(pos,:))),
 					md = checkmessage(md,['no referential should be specified for basal vertices of grounded ice']);
 				end
-				md = checkfield(md,'diagnostic.stokesreconditioning','>',0);
+				md = checkfield(md,'diagnostic.FSreconditioning','>',0);
 			end
 		end % }}}
@@ -144,6 +144,6 @@
 
 			disp(sprintf('\n      %s','Other:'));
-			fielddisplay(obj,'shelf_dampening','use dampening for floating ice ? Only for Stokes model');
-			fielddisplay(obj,'stokesreconditioning','multiplier for incompressibility equation. Only for Stokes model');
+			fielddisplay(obj,'shelf_dampening','use dampening for floating ice ? Only for FS model');
+			fielddisplay(obj,'FSreconditioning','multiplier for incompressibility equation. Only for FS model');
 			fielddisplay(obj,'referential','local referential');
 			fielddisplay(obj,'loadingforce','loading force applied on each point [N/m^3]');
@@ -159,5 +159,5 @@
 			WriteData(fid,'object',obj,'fieldname','abstol','format','Double');
 			WriteData(fid,'object',obj,'fieldname','isnewton','format','Integer');
-			WriteData(fid,'object',obj,'fieldname','stokesreconditioning','format','Double');
+			WriteData(fid,'object',obj,'fieldname','FSreconditioning','format','Double');
 			WriteData(fid,'object',obj,'fieldname','viscosity_overshoot','format','Double');
 			WriteData(fid,'object',obj,'fieldname','maxiter','format','Integer');
Index: issm/trunk-jpl/src/m/classes/diagnostic.py
===================================================================
--- issm/trunk-jpl/src/m/classes/diagnostic.py	(revision 15563)
+++ issm/trunk-jpl/src/m/classes/diagnostic.py	(revision 15564)
@@ -23,5 +23,5 @@
 		self.abstol                   = 0
 		self.isnewton                 = 0
-		self.stokesreconditioning     = 0
+		self.FSreconditioning     = 0
 		self.viscosity_overshoot      = 0
 		self.icefront                 = float('NaN')
@@ -66,6 +66,6 @@
 
 		string="%s\n%s"%(string,'\n      Other:')
-		string="%s\n%s"%(string,fielddisplay(self,'shelf_dampening','use dampening for floating ice ? Only for Stokes model'))
-		string="%s\n%s"%(string,fielddisplay(self,'stokesreconditioning','multiplier for incompressibility equation. Only for Stokes model'))
+		string="%s\n%s"%(string,fielddisplay(self,'shelf_dampening','use dampening for floating ice ? Only for FS model'))
+		string="%s\n%s"%(string,fielddisplay(self,'FSreconditioning','multiplier for incompressibility equation. Only for FS model'))
 		string="%s\n%s"%(string,fielddisplay(self,'referential','local referential'))
 		string="%s\n%s"%(string,fielddisplay(self,'loadingforce','loading force applied on each point [N/m^3]'))
@@ -83,5 +83,5 @@
 		self.abstol=10
 
-		self.stokesreconditioning=10**13
+		self.FSreconditioning=10**13
 		self.shelf_dampening=0
 
@@ -120,5 +120,5 @@
 		md = checkfield(md,'diagnostic.abstol','size',[1])
 		md = checkfield(md,'diagnostic.isnewton','numel',[1],'values',[0,1,2])
-		md = checkfield(md,'diagnostic.stokesreconditioning','size',[1],'NaN',1)
+		md = checkfield(md,'diagnostic.FSreconditioning','size',[1],'NaN',1)
 		md = checkfield(md,'diagnostic.viscosity_overshoot','size',[1],'NaN',1)
 		if md.mesh.dimension==2:
@@ -152,6 +152,6 @@
 					md.checkmessage("Vectors in diagnostic.referential (columns 1 to 3 and 4 to 6) must be orthogonal")
 		#CHECK THAT NO rotation specified for FS Grounded ice at base
-#		if md.mesh.dimension==3 & md.flowequation.isstokes,
-		if md.mesh.dimension==3 and md.flowequation.isstokes:
+#		if md.mesh.dimension==3 & md.flowequation.isFS,
+		if md.mesh.dimension==3 and md.flowequation.isFS:
 			pos=numpy.nonzero(numpy.logical_and(md.mask.vertexongroundedice,md.mesh.vertexonbed))
 			if numpy.any(numpy.logical_not(numpy.isnan(md.diagnostic.referential[pos,:]))):
@@ -168,5 +168,5 @@
 		WriteData(fid,'object',self,'fieldname','abstol','format','Double')
 		WriteData(fid,'object',self,'fieldname','isnewton','format','Integer')
-		WriteData(fid,'object',self,'fieldname','stokesreconditioning','format','Double')
+		WriteData(fid,'object',self,'fieldname','FSreconditioning','format','Double')
 		WriteData(fid,'object',self,'fieldname','viscosity_overshoot','format','Double')
 		WriteData(fid,'object',self,'fieldname','maxiter','format','Integer')
